#ifndef __ETEXT_H__
#define __ETEXT_H__

#include "lblfix.h"

#define CUI_ETEXT_BSIZE	1024
#define CUI_ETEXT_HIST_LEN	20

#define CUI_ETEXT_MODE_NORMAL	(1<<0)
#define CUI_ETEXT_MODE_SELALL	(1<<1)
#define CUI_ETEXT_MODE_EDIT	(1<<2)

typedef struct cui_etext{
	struct cui_base base;
	char buf[ CUI_ETEXT_BSIZE ], bak[ CUI_ETEXT_BSIZE ];
	cui lb_top, lbf, lb_end;
	cui view;

	int mode;
	int n, cursor;
	cui view_cursor, lbf_shadow;

	char hist[ CUI_ETEXT_HIST_LEN ][ CUI_ETEXT_BSIZE ];
	int hist_n;
} *cui_etext;

cui cui_etext_new(cui parent, int x, int y, int w, char *init_s);
void cui_etext_init(cui obj, cui parent, int x, int y, int w, char *init_s);
void cui_etext_hist_add(cui obj);
void cui_etext_cursor_update(cui obj);
int cui_etext_hdr(cui obj, int evt, int val, void *prm);
char *cui_etext_str_get(cui obj);
void cui_etext_str_set(cui obj, char *s);

#endif
