#include "fillbtn.h"
#include "handler.h"
#include "key.h"
#include <stdio.h>

cui
cui_fillbtn_new(cui parent, int x, int y, int w, int h, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_fillbtn));
	cui_fillbtn_init(obj, parent, x, y, w, h, s);
	return obj;
}

void
cui_fillbtn_init(cui obj, cui parent, int x, int y, int w, int h, char *s)
{
	cui_fillbtn p = (cui_fillbtn)obj;
	cui_base_init(obj, parent, x, y, w, h);
	p->fill = cui_fill_new(obj, 0, 0, w, h, s, CUI_ATTR_NORMAL);
	p->v = 0;
	obj->flags |= CUI_FLG_CAN_FOCUS;
	cui_bind(obj, CUI_EVT_DRAW | CUI_EVT_KEY | CUI_EVT_RESIZE, cui_fillbtn_hdr, NULL);
}

int
cui_fillbtn_hdr(cui obj, int evt, int val, void *prm)
{
	cui_fillbtn p = (cui_fillbtn)obj;
	int attr;

	switch(evt){
	case CUI_EVT_DRAW:
		attr = p->v ? CUI_ATTR_REVERSE : (val == CUI_DRAW_FOCUS ? CUI_ATTR_ULINE : CUI_ATTR_NORMAL);
		cui_fill_attr_set(p->fill, attr);
		return TRUE;
	case CUI_EVT_KEY:
		if(val != CUI_KEY_ENTER) break;
		p->v = TRUE;
		cui_draw(obj);
		cui_handler_call(obj, CUI_EVT_BUTTON, p->v);
		p->v = FALSE;
		cui_draw(obj);
		return TRUE;
	case CUI_EVT_RESIZE:
		cui_wh_set(p->fill, obj->w, obj->h);
		return TRUE;
	}
	return FALSE;
}

int
cui_fillbtn_val_get(cui obj)
{
	cui_fillbtn p = (cui_fillbtn)obj;
	return p->v;
}

void
cui_fillbtn_val_set(cui obj, int v)
{
	cui_fillbtn p = (cui_fillbtn)obj;
	p->v = v;
	cui_draw(obj);
}

/* EOF */
