#include "focus.h"
#include "key.h"
#include <stdio.h>

int
cui_focus_glen(cui o1, cui o2, int key)
{
	int dx, dy;

	dx = (cui_gx(o1) + o1->w / 2) - (cui_gx(o2) + o2->w / 2);
	dy = (cui_gy(o1) + o1->h / 2) - (cui_gy(o2) + o2->h / 2);
	dy *= 2;

	switch(key){
	case CUI_KEY_UP:
	case CUI_KEY_DOWN:
		dx *= 4;
		break;
	case CUI_KEY_LEFT:
	case CUI_KEY_RIGHT:
		dy *= 4;
		break;
	}
	return dx * dx + dy * dy;
}

int
cui_focus_move_val(cui obj, int key)
{
	if(cui_focus_get()) return cui_focus_glen(obj, cui_focus_get(), key);

	switch(key){
	case CUI_KEY_UP:
		return cui_gy(obj);
	case CUI_KEY_DOWN:
		return cui_gy(obj) + obj->h;
	case CUI_KEY_LEFT:
		return cui_gx(obj);
	case CUI_KEY_RIGHT:
		return cui_gx(obj) + obj->w;
	}
	return 0;	
}

cui
cui_focus_move_judge_chain(cui obj, int key, cui old, int *val)
{
	if(obj == NULL) return old;
	old = cui_focus_move_judge_chain(obj->next, key, old, val);
	return cui_focus_move_judge(obj, key, old, val);
}

cui
cui_focus_move_judge(cui obj, int key, cui old, int *val)
{
	int v, jg = FALSE;
	cui focus = cui_focus_get();

	if(obj == NULL) return old;
	old = cui_focus_move_judge_chain(obj->children, key, old, val);

	if(obj == focus) return old;
	if(!(obj->flags & CUI_FLG_CAN_FOCUS)) return old;
	if(!cui_is_visible(obj)) return old;
	if(!cui_is_visible_rect(obj)) return old;
	switch(key){
	case CUI_KEY_UP:
	case CUI_KEY_DOWN:
	case CUI_KEY_LEFT:
	case CUI_KEY_RIGHT:
		break;
	default:
		return old;
	}

	v = cui_focus_move_val(obj, key);
	if(focus){
		switch(key){
		case CUI_KEY_UP:
			jg = cui_gy(obj) + obj->h / 2 < cui_gy(focus) + focus->h / 2;
			break;
		case CUI_KEY_DOWN:
			jg = cui_gy(obj) + obj->h / 2 > cui_gy(focus) + focus->h / 2;
			break;
		case CUI_KEY_LEFT:
			jg = cui_gx(obj) + obj->w / 2 < cui_gx(focus) + focus->w / 2;
			break;
		case CUI_KEY_RIGHT:
			jg = cui_gx(obj) + obj->w / 2 > cui_gx(focus) + focus->w / 2;
			break;
		}
		if(old) jg = jg && v < *val;
	}else if(!old){
		jg = TRUE;
	}else{
		switch(key){
		case CUI_KEY_UP:
		case CUI_KEY_LEFT:
			jg = v < *val;
			break;
		case CUI_KEY_DOWN:
		case CUI_KEY_RIGHT:
			jg = v > *val;
			break;
		}
	}
	if(jg) *val = v;
	return jg ? obj : old;
}

/* EOF */
