#include "radio.h"
#include "handler.h"
#include "key.h"
#include <stdio.h>

cui
cui_radio_new(cui parent, int x, int y, char *s, int v)
{
	cui obj = cui_alloc(sizeof(struct cui_radio));
	cui_radio_init(obj, parent, x, y, s, v);
	return obj;
}

void
cui_radio_toggle(cui obj)
{
	int v = cui_radio_val_get(obj);
	v = !v;
	cui_radio_val_set(obj, v);
	cui_handler_call(obj, CUI_EVT_BUTTON, v);
}

cui
cui_radio_sel_get(cui obj)
{
	cui_ckbox ck = (cui_ckbox)obj;
	if(obj == NULL) return NULL;
	if(ck->v) return obj;
	return cui_radio_sel_get(obj->next);
}

int
cui_radio_hdr(cui obj, int evt, int val, void *prm)
{
	cui_radio p = (cui_radio)obj;
	cui old;
	int attr;

	if(evt == CUI_EVT_KEY){
		if(val != CUI_KEY_ENTER) return FALSE;
		if(cui_radio_val_get(obj)) return TRUE;
		old = cui_radio_sel_get(obj->parent->children);
		if(old) cui_radio_toggle(old);
		cui_radio_toggle(obj);
		return TRUE;
	}
	/* CUI_EVT_DRAW */

	cui_label_str_set(p->lb1, cui_radio_val_get(obj) ? "(O) " : "( ) ");
	attr = (val == CUI_DRAW_FOCUS) ? CUI_ATTR_ULINE : CUI_ATTR_NORMAL;
	cui_label_attr_set(p->lb1, attr);
	cui_label_attr_set(p->lb2, attr);
	return TRUE;
}

void
cui_radio_init(cui obj, cui parent, int x, int y, char *s, int v)
{
	cui_ckbox ck = (cui_ckbox)obj;
	cui_radio p = (cui_radio)ck;

	cui_ckbox_init(obj, parent, x, y, s, v);
	p->lb1 = ck->lb1;
	p->lb2 = ck->lb2;
	cui_bind(obj, CUI_EVT_KEY | CUI_EVT_DRAW, cui_radio_hdr, NULL);
}

char *
cui_radio_str_get(cui obj)
{
	return cui_ckbox_str_get(obj);
}

void
cui_radio_str_set(cui obj, char *s)
{
	cui_ckbox_str_set(obj, s);
}

int
cui_radio_val_get(cui obj)
{
	return cui_ckbox_val_get(obj);
}

void
cui_radio_val_set(cui obj, int v)
{
	cui_ckbox_val_set(obj, v);
}

/* EOF */
