#include "scpanel.h"
#include "handler.h"
#include <stdio.h>

cui
cui_scpanel_new(cui parent, int x, int y, int w, int h, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_scpanel));
	cui_scpanel_init(obj, parent, x, y, w, h, s);
	return obj;
}

void
cui_scpanel_init(cui obj, cui parent, int x, int y, int w, int h, char *s)
{
	cui_scpanel p = (cui_scpanel)obj;

	cui_panel_init(obj, parent, x, y, w, h);

	p->view = cui_base_new(obj, 1, 1, w-2, h-2);
	p->sheet = cui_base_new(p->view, 0, 0, w-2, h-2);

	p->vbar = cui_scbar_new(obj, w-1, 1, 1, h-2, 1, 0);
	cui_hide(p->vbar);
	cui_bind(p->vbar, CUI_EVT_BUTTON, cui_scpanel_scbar_hdr, obj);

	p->hbar = cui_scbar_new(obj, 1, h-1, w-2, 1, 1, 0);
	cui_hide(p->hbar);
	cui_bind(p->hbar, CUI_EVT_BUTTON, cui_scpanel_scbar_hdr, obj);

	p->rszbox = cui_rszbox_new(obj);
	p->tbar = s ? cui_tbar_new(obj, s) : NULL;

	cui_bind(obj, CUI_EVT_RESIZE, cui_scpanel_hdr, obj);
	cui_bind(p->sheet, CUI_EVT_RESIZE, cui_scpanel_hdr, obj);
}

int
cui_scpanel_scbar_hdr(cui sb, int evt, int val, void *prm)
{
	cui obj = (cui)prm;
	cui_scpanel p = (cui_scpanel)obj;
	cui_scbar scbar = (cui_scbar)sb;

	if(scbar->hv == CUI_SCBAR_H) cui_x_set(p->sheet, -val);
	else cui_y_set(p->sheet, -val);

	return TRUE;
}

int
cui_scpanel_hdr(cui obj, int evt, int val, void *prm)
{
	cui_scpanel p = (cui_scpanel)prm;

	/* CUI_EVT_RESIZE */

	if(obj == (cui)prm){ /* scapanel */
		cui_wh_set(p->view, obj->w-2, obj->h-2);
		cui_xywh_set(p->vbar, obj->w-1, 1, 1, obj->h-2);
		cui_xywh_set(p->hbar, 1, obj->h-1, obj->w-2, 1);
	}

	if(p->sheet->w > p->view->w){
		cui_scbar_max_set(p->hbar, p->sheet->w - p->view->w);
		cui_show(p->hbar);
	}else{
		cui_hide(p->hbar);
	}

	if(p->sheet->h > p->view->h){
		cui_scbar_max_set(p->vbar, p->sheet->h - p->view->h);
		cui_show(p->vbar);
	}else{
		cui_hide(p->vbar);
	}

	if(p->tbar && obj->w != p->tbar->w) cui_w_set(p->tbar, obj->w);

	return TRUE;
}

cui
cui_scpanel_sheet_get(cui obj)
{
	cui_scpanel p = (cui_scpanel)obj;
	return p->sheet;
}

/* EOF */
