#include "tab.h"
#include "handler.h"
#include <stdio.h>

cui
cui_tab_btn_new(cui parent, int x, int y, char *s, int v)
{
	cui obj = cui_alloc(sizeof(struct cui_tab_btn));
	cui_tab_btn_init(obj, parent, x, y, s, v);
	return obj;
}

void
cui_tab_btn_init(cui obj, cui parent, int x, int y, char *s, int v)
{
	cui_radio rd = (cui_radio)obj;
	cui_tab_btn p = (cui_tab_btn)rd;

	cui_radio_init(obj, parent, x, y, s, v);

	cui_hide(obj);

	p->lb1 = rd->lb1;
	p->lb2 = rd->lb2;
	cui_label_str_set(p->lb1, "/");
	cui_x_set(p->lb2, cui_x2(p->lb1));
	p->lb3 = cui_label_new(obj, cui_x2(p->lb2), 0, "|");
	cui_wh_fit(obj);
	cui_bind(obj, CUI_EVT_DRAW , cui_tab_btn_hdr, NULL);

	cui_show(obj);
}

int
cui_tab_btn_hdr(cui obj, int evt, int val, void *prm)
{
	cui_tab_btn p = (cui_tab_btn)obj;
	int attr, v;
	cui sheet;

	switch(evt){
	case CUI_EVT_DRAW:
		v = cui_tab_btn_val_get(obj);
		attr = v ? CUI_ATTR_NORMAL : CUI_ATTR_ULINE;
		cui_label_attr_set(p->lb1, attr);
		cui_label_attr_set(p->lb3, attr);
		if(val == CUI_DRAW_FOCUS) attr |= CUI_ATTR_REVERSE;
		cui_label_attr_set(p->lb2, attr);
		return TRUE;
	case CUI_EVT_BUTTON:
		sheet = (cui)prm;
		if(val) cui_show(sheet);
		else cui_hide(sheet);
		return TRUE;
	}
	return FALSE;
}

int
cui_tab_btn_val_get(cui obj)
{
	return cui_radio_val_get(obj);
}

void
cui_tab_btn_val_set(cui obj, int v)
{
	cui_radio_val_set(obj, v);
}

cui
cui_tab_new(cui parent, int x, int y, int w, char **lst, cui *sheets, int v)
{
	cui obj = cui_alloc(sizeof(struct cui_tab));
	cui_tab_init(obj, parent, x, y, w, lst, sheets, v);
	return obj;
}

void
cui_tab_init(cui obj, cui parent, int x, int y, int w, char **lst, cui *sheets, int v)
{
	cui btn;
	int i;

	cui_base_init(obj, parent, x, y, w, 1);
	if(lst){
		x = 0;
		for(i=0; lst[i]; i++){
			btn = cui_tab_btn_new(obj, x, 0, lst[i], i == v);
			x = cui_x2(btn);
			cui_bind(btn, CUI_EVT_BUTTON, cui_tab_btn_hdr, sheets[i]);
		}
	}
	if(w < 0) cui_wh_fit(obj);
}

void
cui_tab_add(cui obj, char *s, cui sheet)
{
	cui btn = cui_tab_btn_new(obj, cui_x2(obj->children), 0, s, 0);
	cui_bind(btn, CUI_EVT_BUTTON, cui_tab_btn_hdr, sheet);
}

/* EOF */
